#define MAILBUFEND 128

enum{
	SEND,
	RECV
};

char myselect(
	const SOCKET s,
	const char isRecv,
	const time_t timeout)
{
	fd_set fs;
	struct timeval tv;
	int ret;
	
	FD_ZERO(&fs);
	FD_SET(s,&fs);
	
	tv.tv_sec=timeout;
	tv.tv_usec=0;
	
	if(isRecv==SEND){
		ret=select(s+1, NULL, &fs, NULL, &tv);	//SENDł悤ɂȂ܂ő҂
	}
	else{
		ret=select(s+1, &fs, NULL, NULL, &tv);	//RECVł悤ɂȂ܂ő҂
	}
	
	if(ret==0){
//		fprintf(stderr,"^CAEg\n");
		konhyouji(hEdit,"^CAEg\r\n");
		return 1;
	}
	else if(ret==-1){
//		fprintf(stderr,"select()ŃG[\n");
		konhyouji(hEdit,"select()ŃG[\r\n");
		return 1;
	}
	
	return 0;
}

/*
SEND
cp̂ȂSENDĂĂ

߂lF0AG[1
*/
char mysend(
	const SOCKET s,
	char *cp,
	const time_t timeout)
{
//	printf("S\t");
	konhyouji(hEdit,"S\t");
	
	if(myselect(s,SEND,timeout))	return 1;
	
//	printf(cp);
	konhyouji(hEdit,cp);
	
	if((send(s,cp,strlen(cp),0))==-1){
//		fprintf(stderr,"send()ŃG[\n");
		konhyouji(hEdit,"send()ŃG[\r\n");
		return 1;
	}
	
	return 0;
}

/*
RECV
ŌCP̂ȂRECVŕԂĂ񂪂͂Ă

߂lF0AG[1
*/
char myrecv(
	const SOCKET s,
	char *cp,
	const size_t cpsize,
	const time_t timeout)
{
//	printf("R\t");
	konhyouji(hEdit,"R\t");
	
	if(myselect(s,RECV,timeout))	return 1;
	
	memset(cp,0,cpsize);
	
	if((recv(s,cp,cpsize,0))==-1){
//		fprintf(stderr,"recv()ŃG[\n");
		konhyouji(hEdit,"recv()ŃG[\r\n");
		return 1;
	}
	
//	printf(cp);
	konhyouji(hEdit,cp);
	
	if(strstr(cp,"+OK")!=cp){
//		fprintf(stderr,"+OKԂĂȂ\n");
		konhyouji(hEdit,"+OKԂĂȂ\r\n");
		return 1;
	}

	return 0;
}

/*
SENDRECV
cp̂ȂSENDĂĂ
ŌCP̂ȂRECVŕԂĂ񂪂͂Ă

߂lF0AG[1
*/
char sendrecv(
	const SOCKET s,
	char *cp,
	const size_t cpsize,
	const time_t timeout)
{
	if(mysend(s,cp,timeout))	return 1;
	if(myrecv(s,cp,cpsize,timeout))	return 1;
	
	return 0;
}

/************************************************************
\PbgI[vCړĨT[õ|[gɐڑ
server:		T[o̖OihCChCȗĂ͂Ȃj
			Ⴆss2.tokyo-ct.ac.jp
servicename:"smtp"Ƃ"http"Ȃǂ̃T[rX̖OC
			̂ƂɖÖꗗ
			WindowsVXesystem32\drivers\etc\services
service:	T[rX̃|[gԍCsmtpȂ25ChttpȂ80Ȃ
			̏́Cservicenames̏ꍇɕKvȂŁC
			ʏ͎gȂ
sȂINVALID_SOCKETԂ
*************************************************************/
SOCKET connectSocket(const char *server, char *servicename, short int service)
{
	WSADATA wsaData; /*winsock*/
	LPHOSTENT lpHost;
	LPSERVENT lpServ;
	SOCKET sock;
	SOCKADDR_IN sockAddr;
	int port; /*|[gԍ*/
	int status;

	/*winsockver1.1ŏv*/
	status=WSAStartup(MAKEWORD(1, 1), &wsaData);
	if (status != 0) {
//		fprintf(stderr,"WSAStartup() failed\n");
		konhyouji(hEdit,"WSAStartup() failed\r\n");
		return INVALID_SOCKET;
	}

	/*T[ozXg̏𓾂*/
	lpHost = gethostbyname(server);
	if(lpHost == NULL) {
//		fprintf(stderr,"server name error\n");
		konhyouji(hEdit,"server name error\r\n");
		WSACleanup();
		return INVALID_SOCKET;
	}

	/*T[rX񂩂|[gԍ擾*/
	lpServ = getservbyname(servicename, NULL);
	if (lpServ == NULL) {
		port=htons(service);
		/*zXgoCgI[_[lbg[NoCgI[_[irbOGfBAjɕϊ*/
	} else {
		port=lpServ->s_port;
	}

	/*\PbgI[v*/
	sock = socket(PF_INET, SOCK_STREAM, 0);
	if (sock == INVALID_SOCKET) {
//		fprintf(stderr,"socket() error\n");
		konhyouji(hEdit,"socket() error\r\n");
		WSACleanup();
		return INVALID_SOCKET;
	}

	/*\Pbg*/
	sockAddr.sin_family = AF_INET;
	sockAddr.sin_port = port;
	sockAddr.sin_addr = *((LPIN_ADDR)*lpHost->h_addr_list);
	status=connect(sock, (PSOCKADDR)&sockAddr, sizeof(SOCKADDR_IN));
	if (status) {
//		fprintf(stderr,"connect() error\n");
		konhyouji(hEdit,"connect() error\r\n");
		closesocket(sock);
		WSACleanup();
		return INVALID_SOCKET;
	}
	return sock;
}

/*
POP3ɃOC
connectSocket()̂ƂɂĂ

߂l
G[F1
F0
*/
char pop3login(
	const SOCKET s,
	const char *user,
	const char *pass,
	const time_t timeout)
{
	char buf[MAILBUFEND];
	
	/*T[oM*/
	if(myrecv(s,buf,MAILBUFEND,timeout))	return 1;
	
	/*[Ulogin*/
	sprintf(buf,"USER %s\r\n",user);
	if(sendrecv(s,buf,MAILBUFEND,timeout))	return 1;
	
	/*pX[h*/
	sprintf(buf,"PASS %s\r\n",pass);
	if(sendrecv(s,buf,MAILBUFEND,timeout))	return 1;
	
	return 0;
}

/*
[̂Ԃ

߂l
G[F-1
F[̐
*/
int getMailKazu(
	const SOCKET s,
	const time_t timeout)
{
	char buf[MAILBUFEND];
	
	/*[Xg̎擾*/
	sprintf(buf,"STAT\r\n");
	if(sendrecv(s,buf,MAILBUFEND,timeout))	return -1;
	
	return atoi(buf+4);	//+OK [ oCg
}
